// Definiciones de elementos geomtricos

using namespace std;

//******************** CLASE PUNTO ***************************************************************
class punto {

public:

	int x, y;

public:

	punto ( int x=0 , int y=0); // constructor por defecto

};

// constructor de oficio

punto :: punto ( int _x , int _y ) { x = _x ; y = _y ; }

//***********************************************************************************
punto origen=punto(0,0);
//***********************************************************************************
//***********************************************************************************
punto centro( BITMAP * bmp ) {

	punto centro;

	centro.x = ( bmp->w )/2;

	centro.y = ( bmp->h )/2;

	return centro;

}
//************************* CLASE PIXEL **********************************************************
class pixel {

public:

	punto p;

	int color;

	BITMAP * bmp;

public:

	pixel ( punto p = punto(0,0) , int color=C.WHITE , BITMAP *bmp=NULL ); 

public:

	void pon(){
	
		putpixel(this->bmp , this->p.x , this->p.y , this->color);
	
	}
	
};

// Constructor de oficio

pixel :: pixel ( punto _p , int _color , BITMAP * _bmp ) {

	p = _p;

	color = _color;

	bmp = _bmp;

}

//****************** CLASE LINEA *****************************************************************

class linea{

public:

	punto p1, p2;

	int color;

	BITMAP* bmp;


public:

	linea( punto p1=punto(0,0) , punto p2=punto(0,0) , int color = C.WHITE , BITMAP* bmp = NULL );

	// As definimos el constructor por defecto.

public:

	void pon(){ 
	
		line( this->bmp , this->p1.x , this->p1.y , this->p2.x , this->p2.y , this->color );
	
	}

};

// Constructor de oficio

linea :: linea( punto _p1, punto _p2, int _color, BITMAP* _bmp ){

	p1=_p1;
	p2=_p2;
	color=_color;
	bmp=_bmp;

}


//***********************************************************************************


//****************** CLASE CRCULO ****************************************************

class circulo {

public:

	punto centro;

	int radio;

	int color;

	BITMAP* bmp;

public:

	circulo ( punto centro=punto(0,0) , int radio=0, int color=C.WHITE, BITMAP* bmp=NULL );
	// El constructor por defecto

public:

	void pon(){
	
		circle(this->bmp, this->centro.x, this->centro.y, this->radio, this->color);
		
	}

	void ponf(){
	
		circlefill( this->bmp, this->centro.x, this->centro.y, this->radio, this->color );
		
	}

};

// Su constructor de oficio

circulo :: circulo ( punto _centro, int _radio, int _color, BITMAP* _bmp ){

	centro = _centro;

	radio = _radio;

	color = _color;

	bmp = _bmp;
	
}

// *****************************************************************************************

class triangulo { 

public:

	punto v1, v2, v3;

	int color;

	BITMAP* bmp;
	
public:

	triangulo ( punto v1=punto(0,0), punto v2=punto(0,0), punto v3=punto(0,0), int color=C.WHITE, BITMAP* bmp=NULL );

	// Constructor por defecto

public:

	void pon(){
	
		line( this->bmp, this->v1.x , this->v1.y , this->v2.x , this->v2.y , this->color ); // v1 -> v2
		line( this->bmp, this->v2.x , this->v2.y , this->v3.x , this->v3.y , this->color ); // v2 -> v3
		line( this->bmp, this->v3.x , this->v3.y , this->v1.x , this->v1.y , this->color ); // v3 -> v1
		
	}

	void ponf(){

		triangle( this->bmp, this->v1.x , this->v1.y , this->v2.x , this->v2.y , this->v3.x , this->v3.y , this->color );

	}



};

triangulo :: triangulo ( punto _v1, punto _v2, punto _v3, int _color, BITMAP* _bmp ) {

	v1 = _v1;

	v2 = _v2;

	v3 = _v3;

	color = _color;

	bmp = _bmp;

}

// *********************** CLASE QUAD ****************************

class quad {

public:

	punto p1, p2;

	int anchura, altura;

	int color;

	BITMAP* bmp;

	bool libre;
	bool deplayer1;
	bool deplayer2;

public:

	quad( punto p1=punto(0,0), punto p2=punto(0,0), int anchura=0, int altura=0, int color=C.WHITE, 
		BITMAP* bmp=NULL, bool libre=true, bool deplayer1=false, bool deplayer2=false );

	// Constructor por defecto. Para declarar un cuadrado genrico

public:

	void pon( int color){
	
		rect( this->bmp, this->p1.x , this->p1.y, this->p2.x, this->p2.y, color );

	}

	

	void ponf( int color ){
	
		rectfill(  this->bmp, this->p1.x , this->p1.y, this->p2.x, this->p2.y, color );
		
	}

	
};

quad :: quad ( punto _p1, punto _p2, int _anchura, int _altura, int _color, BITMAP* _bmp, 
	bool _libre, bool _deplayer1, bool _deplayer2 ){

	p1 = _p1;

	p2 = _p2;


	if( _anchura==0 ){ anchura = abs(p2.x - p1.x); } else { anchura = _anchura; }

	if( _altura == 0 ){  altura = abs( p2.y - p1.y ); } else { altura = _altura; }

	color = _color;

	bmp = _bmp;

	libre = _libre;

	deplayer1 = _deplayer1;
	deplayer2= _deplayer2;
	
}


class player {
public:
	bool turno;
	int fichas;// mximo=3
	
public:
	player( bool turno=false, int fichas=0 ); // constructor por defecto
	  
	};
// ahora definimos su constructor de oficio
player :: player ( bool _turno, int _fichas ) {

	turno = _turno;
	fichas=_fichas;
	}

